<?php
/**
 * Created by PhpStorm.
 * User: fanyongsheng
 * Date: 2016/11/16
 * Time: 17:22
 */


class Sing
{
    private $id;
    private $strid;
    private $appid;
    private $timestamp;
    private $privateKeyFilePath = 'pem/private_rsa.pem'; //私钥相对路径

    function __construct()
    {
        date_default_timezone_set("Asia/Shanghai");

        if($_REQUEST['id'] && $_REQUEST['appid'] && $_REQUEST['strid']){

        }else{
            $this->returnMessage(209,'','请提交完成的参数');
            exit;
        }


        $this->id = $_REQUEST['id']? $_REQUEST['id']:'';
        $this->appid = strtoupper($_REQUEST['appid']);
        $this->strid = $_REQUEST['strid']?$_REQUEST['strid']:'';
        $this->timestamp = time()-60*60*8;
    }


    public function getSing()
    {
        /**
         * 密钥文件的路径
         */
        $privateKeyFilePath = $this->privateKeyFilePath;

        extension_loaded('openssl') or die('php需要openssl扩展支持');

        (file_exists($privateKeyFilePath)) or die('密钥或者公钥的文件路径不正确');
        /**
         * 生成Resource类型的密钥，如果密钥文件内容被破坏，openssl_pkey_get_private函数返回false
         */
        $privateKey = openssl_pkey_get_private(file_get_contents($privateKeyFilePath));
        /**
         * 生成Resource类型的公钥，如果公钥文件内容被破坏，openssl_pkey_get_public函数返回false
         */

        ($privateKey) or die('密钥或者公钥不可用');
        /**
         * 原数据
         *
         *
         */
        $originalData = '{"id":'.$this->id.', "strid":"'.$this->strid.'", "appid":"'.$this->appid.'", "timestamp":'.$this->timestamp.'}';

        $originalData = md5($originalData);

        /**
         * 加密以后的数据，用于在网路上传输
         */
        $encryptData = '';

        $arr = array();

///////////////////////////////用私钥加密////////////////////////


        if (openssl_private_encrypt($originalData, $encryptData, $privateKey)) {
            return $arr['sign'] =  base64_encode($encryptData);
        } else {
            die('加密失败');
        }
    }

    public function returnMessage($code,$data,$message){
        $ext = array('timestamp'=>$this->timestamp,'appid'=>$this->appid,'strid'=>$this->strid,'id'=>$this->id);
        $result = array('errcode'=>$code,'sign'=>$data,'message'=>$message,'ext'=>$ext);
        echo json_encode($result);
    }
}

